package top.xkshadow.SkyHole.Task.Server;

import cn.nukkit.Server;
import cn.nukkit.scheduler.PluginTask;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import top.xkshadow.SkyHole.Main;

public class DelayTaskControll extends PluginTask<Main> {
   private static HashMap<Integer, DelayTask> array = new HashMap();

   public DelayTaskControll(Main owner) {
      super(owner);
   }

   public void onRun(int i) {
      this.refresh();
   }

   private void refresh() {
      ArrayList<Integer> remove = new ArrayList();
      Iterator var2 = ((HashMap)array.clone()).keySet().iterator();

      int key;
      while(var2.hasNext()) {
         key = (Integer)var2.next();
         DelayTask task = (DelayTask)array.get(key);
         int time = task.tick;
         if (time <= 0) {
            try {
               task.task.run();
            } catch (Exception var7) {
               Server.getInstance().getLogger().info(var7.getMessage());
            }

            remove.add(key);
         } else {
            --task.tick;
            array.put(key, task);
         }
      }

      var2 = remove.iterator();

      while(var2.hasNext()) {
         key = (Integer)var2.next();
         array.remove(key);
      }

   }

   public static void addTask(Runnable task, int tick) {
      int id;
      for(id = 0; array.containsKey(id); ++id) {
      }

      array.put(id, new DelayTask(task, tick));
   }
}
