package top.xkshadow.SkyHole.account;

import cn.nukkit.Player;
import cn.nukkit.Server;
import cn.nukkit.utils.Config;
import top.xkshadow.SkyHole.data.ConfigData;
import top.xkshadow.SkyHole.data.Data;

public class Controll {
   private static void check(Player p, String key) {
      String name = p.getName();
      check(name, key);
   }

   private static void check(String name, String key) {
      Config cfg = ConfigData.getPlayerConfig(name);
      if (!cfg.exists(key)) {
         cfg.set(key, Data.getInit(key));
         cfg.save();
      }

   }

   private static void check(Config cfg, String key) {
      if (!cfg.exists(key)) {
         cfg.set(key, Data.getInit(key));
         cfg.save();
      }

   }

   public static void setData(Player p, String key, Object val) {
      Config cfg = ConfigData.getPlayerConfig(p);
      cfg.set(key, val);
      cfg.save();
   }

   public static void setData(String name, String key, Object val) {
      Config cfg = ConfigData.getPlayerConfig(name);
      cfg.set(key, val);
      cfg.save();
   }

   public static Object getData(Player p, String key) {
      check(p, key);
      Config cfg = ConfigData.getPlayerConfig(p);
      Object data = cfg.get(key);
      return data;
   }

   public static Object getData(Config cfg, String key) {
      check(cfg, key);
      Object data = cfg.get(key);
      return data;
   }

   public static Object getData(String name, String key) {
      check(name, key);
      Config cfg = ConfigData.getPlayerConfig(name);
      Object data = cfg.get(key);
      return data;
   }

   public static void addData(Player p, String key, int val) {
      addData(p.getName(), key, val);
   }

   public static void addData(String p, String key, int val) {
      check(p, key);
      Config cfg = ConfigData.getPlayerConfig(p);
      if (cfg.get(key) instanceof Integer) {
         cfg.set(key, (Integer)cfg.get(key) + val);
         cfg.save();
      } else {
         Server.getInstance().getLogger().warning("addData错误: " + key + " 不是整形,无法增加 " + val);
      }

   }
}
