package top.xkshadow.SkyHole.data;

import cn.nukkit.Player;
import cn.nukkit.utils.Config;
import java.io.File;
import top.xkshadow.SkyHole.Main;

public class ConfigData {
   public static boolean hasPlayerConfig(String name) {
      name = name.toLowerCase();
      return (new File(Main.getFolder() + "/player/" + name + ".yml")).exists();
   }

   public static Config getPlayerConfig(String name) {
      Config cfg = new Config(Main.getFolder() + "/player/" + name + ".yml", 2);
      return cfg;
   }

   public static Config getPlayerConfig(Player p) {
      String name = p.getName();
      Config cfg = new Config(Main.getFolder() + "/player/" + name + ".yml", 2);
      return cfg;
   }
}
