package top.xkshadow.SkyHole.listener;

import cn.nukkit.Player;
import cn.nukkit.Server;
import cn.nukkit.entity.Entity;
import cn.nukkit.event.EventHandler;
import cn.nukkit.event.entity.EntityDamageByEntityEvent;
import cn.nukkit.event.entity.EntityDamageEvent;
import cn.nukkit.event.entity.EntityDamageEvent.DamageCause;
import cn.nukkit.event.player.PlayerJoinEvent;
import cn.nukkit.event.player.PlayerQuitEvent;
import cn.nukkit.event.player.PlayerTeleportEvent;
import cn.nukkit.item.Item;
import cn.nukkit.level.Sound;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Objects;
import top.xkshadow.SkyHole.Itemcontrol;
import top.xkshadow.SkyHole.KIll;
import top.xkshadow.SkyHole.Main;
import top.xkshadow.SkyHole.MessageControll;
import top.xkshadow.SkyHole.Sounds;

public class Listener implements cn.nukkit.event.Listener {
   public static HashMap<Long, ArrayList<String>> killmap = new HashMap();

   @EventHandler
   public void onDamageByEntity(EntityDamageByEntityEvent event) {
      if (event.getDamager() instanceof Player) {
         Player p = (Player)event.getDamager();
         String playerworld = p.getLevelName();
         if (playerworld.equals(Main.gameworld) && !(Boolean)Main.playerpvp.get(p)) {
            event.setCancelled();
            p.sendMessage("请跳下天坑开始战斗");
         }
      }

   }

   @EventHandler
   public void onHit(EntityDamageByEntityEvent e) {
      Entity ent = e.getEntity();
      ArrayList<String> array = new ArrayList();
      if (e.getDamager() instanceof Player) {
         array.add(e.getDamager().getName());
         array.add(((Player)e.getDamager()).getInventory().getItemInHand().getName());
         killmap.put(ent.getId(), array);
      }

   }

   @EventHandler
   public void onDie(EntityDamageEvent e) {
      if (!e.isCancelled()) {
         Entity ent = e.getEntity();
         if (ent instanceof Player) {
            Player p = ((Player)ent).getPlayer();
            String playerworld = p.getLevelName();
            if (playerworld.equals(Main.gameworld)) {
               double Damage = (double)e.getFinalDamage();
               if (1.0D + Damage >= (double)p.getHealth() && !p.getOffhandInventory().contains(Item.fromString("minecraft:totem_of_undying"))) {
                  e.setCancelled();
                  callDeath(p);
               }
            }
         }

      }
   }

   public static void callDeath(Player p) {
      p.sendTitle("§c复仇吧！", "");
      Sounds.waitSound((Entity)p, Sound.MOB_WITCH_CELEBRATE, 10);
      p.setHealth((float)p.getMaxHealth());
      p.removeAllEffects();
      p.getInventory().clearAll();
      p.teleport(Server.getInstance().getLevelByName(Main.gameworld).getSpawnLocation());
      if (killmap.containsKey(p.getId())) {
         ArrayList<String> array = (ArrayList)killmap.get(p.getId());
         MessageControll.sendLevel(p.level, p.getName() + " §e被 " + (String)array.get(0) + " §e使用 " + (String)array.get(1) + " §e消灭了");
         Player killer = Server.getInstance().getPlayer((String)array.get(0));
         int kill = KIll.getplayerkillnum(killer);
         KIll.setplayerkillnum(killer, kill + 1);
         int keepkill = KIll.getplayerkeepkillnum(killer);
         int newkill = keepkill + 1;
         KIll.setplayerkeepkillnum(killer, newkill);
         String killtitle = null;
         if (newkill >= 2) {
            MessageControll.sendLevel(p.getLevel(), killer.getName() + "§c连续击杀" + newkill + "名玩家！§e快去阻止他！");
            Iterator var7 = killer.getLevel().getPlayers().values().iterator();

            while(var7.hasNext()) {
               Player pl = (Player)var7.next();
               Sounds.waitSound((Entity)pl, Sound.MOB_CAT_MEOW, 5);
            }
         }

         killer.sendTitle((String)killtitle, "§c" + newkill + "杀");
         Sounds.addSound((Entity)killer, Sound.MOB_WOLF_WHINE);
         killmap.remove(p.getId());
      } else {
         MessageControll.sendLevel(p.level, p.getName() + " §e消灭了自己");
      }

      int dead = KIll.getplayerdeadnum(p);
      KIll.setplayerdeadnum(p, dead + 1);
      KIll.setplayerkeepkillnum(p, 0);
   }

   @EventHandler
   public void EntityDamageEvent(EntityDamageEvent event) {
      if (event.getEntity().isPlayer) {
         Player p = (Player)event.getEntity();
         if (event.getCause() == DamageCause.FALL) {
            String worldname = p.getLevel().getFolderName();
            if (Objects.equals(worldname, Main.gameworld) && !(Boolean)Main.playerpvp.get(p)) {
               p.sendTitle("战斗吧！");
               Main.playerpvp.put(p, true);
               Itemcontrol.giveinv(p);
               Itemcontrol.giveArmor(p);
               Sounds.addSound((Entity)p, Sound.RANDOM_ANVIL_LAND);
               event.setCancelled();
            }
         }
      }

   }

   @EventHandler
   public void TeleportCheck(PlayerTeleportEvent event) {
      Player p = event.getPlayer();
      if (Objects.equals(Main.gameworld, event.getTo().getLocation().getLevelName())) {
         Main.playerpvp.put(p, false);
      } else {
         Main.playerpvp.remove(p);
      }

   }

   @EventHandler
   public void PlayerJoinEvent(PlayerJoinEvent event) {
      Player p = event.getPlayer();
      if (Objects.equals(Main.gameworld, p.getLevel().getFolderName())) {
         Main.playerpvp.put(p, false);
         p.setHealth((float)p.getMaxHealth());
         p.removeAllEffects();
         p.getInventory().clearAll();
         p.teleport(Server.getInstance().getLevelByName(Main.gameworld).getSpawnLocation());
      }

   }

   @EventHandler
   public void PlayerQuitEvent(PlayerQuitEvent event) {
      Player p = event.getPlayer();
      Main.playerpvp.remove(p);
   }
}
